
if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_CallRoutes' ) )
	drop table A_CallRoutes
GO

Create Table dbo.A_CallRoutes
(
   Id uniqueidentifier,
   Name nvarchar ( 200 ),
   Description nvarchar ( 1000 ),
   Command nvarchar ( 1000 ),
   IsExternal bit,
   Enabled bit,
   Type int
)
GO


if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_CallRoutes_GetAll' ) )
	drop procedure A_CallRoutes_GetAll
GO

Create procedure dbo.A_CallRoutes_GetAll
as
begin
	Select Id, Name, Description, Command, IsExternal, Enabled, Type
	From A_CallRoutes
	Order By Name
end
GO


if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_CallRoutes_Save' ) )
	drop procedure A_CallRoutes_Save
GO

Create procedure dbo.A_CallRoutes_Save
	@id uniqueidentifier,
	@name nvarchar ( 200 ),
   	@description nvarchar ( 1000 ),
   	@command nvarchar ( 1000 ),
	@isexternal bit,
	@enabled bit,
	@type int
as
begin
	Update A_CallRoutes
	Set 	Name = @name,
		Description = @description,
		Command = @command,
		IsExternal = @isexternal,
		Enabled = @enabled,
		Type = @type
	Where Id = @id

	if ( @@rowcount = 0 )
		Insert into A_CallRoutes ( Id, Name, Description, Command, IsExternal, Enabled, Type )
		Values ( @id, @name, @description, @command, @isexternal, @enabled, @type )
end
GO

