
if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_ServerStreams' ) )
	if not Exists ( Select * From INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_ServerStreams' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'Account' )
	Alter Table dbo.A_ServerStreams
	Add Account nvarchar ( 500 )
GO

if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_ServerStreams' ) )
	Update A_ServerStreams
	Set Account = ''
	Where Account is Null
GO

if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_ServerStreams' ) )
	if not Exists ( Select * From INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_ServerStreams' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'RegType' )
	Alter Table dbo.A_ServerStreams
	Add RegType int default 0
GO

if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_ServerStreams' ) )
	Update A_ServerStreams
	Set RegType = 0
	Where RegType is Null
GO


if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_Admin_OfficeMap_ServerStream_Get' ))
	Drop procedure dbo.A_Admin_OfficeMap_ServerStream_Get
GO

Create procedure dbo.A_Admin_OfficeMap_ServerStream_Get
	@idserver uniqueidentifier
as
begin
	if ( @idserver = '00000000-0000-0000-0000-000000000000' )
		Select Id, Name, IdServer, Type, Account, RegType
		From A_ServerStreams	
	else
		Select Id, Name, IdServer, Type, Account, RegType
		From A_ServerStreams
		Where IdServer = @idserver
end
GO


if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_Admin_OfficeMap_ServerStream_Set' ))
	Drop procedure dbo.A_Admin_OfficeMap_ServerStream_Set
GO

Create procedure dbo.A_Admin_OfficeMap_ServerStream_Set
	@id uniqueidentifier,
	@name nvarchar ( 500 ),
	@idserver uniqueidentifier,
	@type int,
	@account nvarchar ( 500 ) = '',
	@regtype int = 0
as
begin
	Insert into A_ServerStreams ( Id, Name, IdServer, Type, Account, RegType )
	Values ( @id, @name, @idserver, @type, @account, @regtype )
end
GO