

if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_ServerStreams' ) )
	if not Exists ( Select * From INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_ServerStreams' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'GateId' )
	Alter Table dbo.A_ServerStreams
	Add GateId uniqueidentifier
GO


if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_ServerStreams' ) )
	Update A_ServerStreams
	Set GateId = '00000000-0000-0000-0000-000000000000'
	Where GateId is Null
GO


if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_Admin_OfficeMap_ServerStream_Set' ) )
	Drop procedure dbo.A_Admin_OfficeMap_ServerStream_Set
GO

Create procedure dbo.A_Admin_OfficeMap_ServerStream_Set
	@id uniqueidentifier,
	@name nvarchar ( 500 ),
	@idserver uniqueidentifier,
	@type int,
	@account nvarchar ( 500 ) = '',
	@regtype int = 0,
	@gateid uniqueidentifier = '00000000-0000-0000-0000-000000000000'
as
begin
	Insert into A_ServerStreams ( Id, Name, IdServer, Type, Account, RegType, GateId )
	Values ( @id, @name, @idserver, @type, @account, @regtype, @gateid )
end
GO


if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_Admin_OfficeMap_ServerStream_Get' ) )
	Drop procedure dbo.A_Admin_OfficeMap_ServerStream_Get
GO

Create procedure dbo.A_Admin_OfficeMap_ServerStream_Get
	@idserver uniqueidentifier
as
begin
	if ( @idserver = '00000000-0000-0000-0000-000000000000' )
		Select Id, Name, IdServer, Type, Account, RegType, GateId
		From A_ServerStreams	
	else
		Select Id, Name, IdServer, Type, Account, RegType, GateId
		From A_ServerStreams
		Where IdServer = @idserver
end
GO


if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_ServerGates' ) )
	Drop table dbo.A_ServerGates
GO

Create Table dbo.A_ServerGates
( 
	Id uniqueidentifier primary key,
	Name nvarchar ( 100 ),
	IdServer uniqueidentifier,
	RegType int
)
GO


if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_Admin_OfficeMap_ServerGate_Clear' ) )
	Drop procedure dbo.A_Admin_OfficeMap_ServerGate_Clear
GO

Create procedure dbo.A_Admin_OfficeMap_ServerGate_Clear
as
begin
	Delete 
	From A_ServerGates
end
GO


if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_Admin_OfficeMap_ServerGate_Set' ) )
	Drop procedure dbo.A_Admin_OfficeMap_ServerGate_Set
GO

Create procedure dbo.A_Admin_OfficeMap_ServerGate_Set
	@id uniqueidentifier,
	@name nvarchar ( 500 ),
	@idserver uniqueidentifier = '00000000-0000-0000-0000-000000000000',
	@regtype int
as
begin
	Insert into A_ServerGates ( Id, Name, IdServer, RegType )
	Values ( @id, @name, @idserver, @regtype )
end
GO


if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_Admin_OfficeMap_ServerGate_Get' ) )
	Drop procedure dbo.A_Admin_OfficeMap_ServerGate_Get
GO

Create procedure dbo.A_Admin_OfficeMap_ServerGate_Get	
	@idserver uniqueidentifier
as
begin
	if ( @idserver = '00000000-0000-0000-0000-000000000000' )
		Select sg.Id, sg.Name, sg.IdServer, sg.RegType
		From A_ServerGates sg
	else
		Select sg.Id, sg.Name, sg.IdServer, sg.RegType
		From A_ServerGates sg
		Where sg.IdServer = @idserver
end
GO
