if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_CallCenter_Info_GetOperatorIndexes' ) )
	Drop procedure dbo.A_CallCenter_Info_GetOperatorIndexes
GO

Create procedure dbo.A_CallCenter_Info_GetOperatorIndexes
	@iduser uniqueidentifier,
	@dtnow datetime = null
as
begin
------------------------------
/*
	declare @iduser uniqueidentifier, @dtnow datetime
	select @iduser = 'DA803F01-EA77-40FA-BC9D-E2EFB36FD5A8', @dtnow = null
*/
------------------------------
    if ( @dtnow is null )
	set @dtnow = GetDate ( )


    declare @dtday datetime
    set @dtday = Cast ( Floor ( Cast ( @dtnow as float ) ) as datetime )

    if ( @iduser = '00000000-0000-0000-0000-000000000000' )
    begin
	--    

	SET TRANSACTION ISOLATION LEVEL READ UNCOMMITTED

	--   
	Declare @users table ( Id uniqueidentifier )
	Insert into @users
		Select Id 
		From A_Users u
			Inner join A_UserParams up on u.Id = up.IdUser
		Where IsOperator = 1

	--   
	Declare @res table ( IdUser uniqueidentifier, CountSuccess int, AuthorizedSec float, CCSec float, CCOnlineSec float, CCLunchSec float )
	
	Insert into @res
		Select Id, 0, 0, 0, 0, 0
		From @users

	--     

	declare @tmp1 table ( IdOperator uniqueidentifier, Cnt int )
	Insert into @tmp1
	    Select IdOperator, Count ( * ) As Cnt
	    From (
		Select IdOperator, IdChain
		From (
			Select IdOperator, IdChain, CallResult
			From oktell_cc_temp.dbo.A_Cube_CC_EffortConnections ec With ( Index ( idxCubeConnections_DateTimeStart ) )
				Inner join @users u on ec.IdOperator = u.Id
			Where DateTimeStart > @dtday
				And CallResult = 5
			)a
		Group By IdOperator, IdChain
		)b
	    Group By IdOperator

	Update r
	Set CountSuccess = Cnt
	From @res r, @tmp1 t
	Where r.IdUser = t.IdOperator


	--    
	Declare @tstates table ( IdOperator uniqueidentifier, State int, LenSec float )

	Insert into @tstates
  	    Select OperatorId, State, Sum ( Cast ( TimeLeave - TimeEnter as float ) * 86400 ) as LenSec
	    From
	    (
		Select OperatorId, State, 
			case when TimeEnter < @dtday then @dtday else timeenter end as TimeEnter,
			IsNull ( TimeLeave, @dtnow ) as TimeLeave
		FROM A_Callcenter_UserStateHistory ush
			Inner join @users u on ush.OperatorId = u.Id
		Where ( TimeLeave > @dtday or TimeLeave is Null )
	    ) a
	    Group By OperatorId, State

	--   
	Update r
	Set AuthorizedSec = LenSec
	From @res r, @tstates t
	Where r.IdUser = t.IdOperator
		And t.State = 0

	--   -
	Update r
	Set CCSec = LenSec
	From @res r, @tstates t
	Where r.IdUser = t.IdOperator
		And t.State = 1

	--    -
	Update r
	Set CCOnlineSec = LenSec
	From @res r, @tstates t
	Where r.IdUser = t.IdOperator
		And t.State = 2

	--    -
	Update r
	Set CCLunchSec = LenSec
	From @res r, @tstates t
	Where r.IdUser = t.IdOperator
		And t.State = 3
	
	SET TRANSACTION ISOLATION LEVEL READ COMMITTED

	Select * From @res

    end
    else
    begin
	
	SET TRANSACTION ISOLATION LEVEL READ UNCOMMITTED

	declare @cntsuccess int, @worklen float, @cclen float, @cconlinelen float, @cclunchlen float
	
	--     
	Select @cntsuccess = Count ( * ) From
	(
		Select distinct IdChain
		From oktell_cc_temp.dbo.A_Cube_CC_EffortConnections ec With ( Index ( idxCubeConnections_DateTimeStart ) )
		Where DateTimeStart > @dtday
			and CallResult = 5
			and IdOperator = @iduser		
	) a

	if exists ( select * FROM tempdb..sysobjects where id = object_id ( 'tempdb..#tstates' ) )
		drop table #tstates

	Select State, Sum ( Cast ( TimeLeave - TimeEnter as float ) * 86400 ) as LenSec Into #tstates 
	From
	(		
		Select State, case when TimeEnter < @dtday then @dtday else timeenter end as TimeEnter,
			IsNull ( TimeLeave, @dtnow ) as TimeLeave
		FROM A_Callcenter_UserStateHistory
		Where OperatorId = @iduser
			and ( TimeLeave > @dtday or TimeLeave is Null )
	) a
	Group By State

	SET TRANSACTION ISOLATION LEVEL READ COMMITTED		

	Select @worklen = LenSec From #tstates Where State = 0
	Select @cclen = LenSec From #tstates Where State = 1
	Select @cconlinelen = LenSec From #tstates Where State = 2
	Select @cclunchlen = LenSec From #tstates Where State = 3


	Select IsNull ( @cntsuccess, 0 ) as CountSuccess, 
		IsNull ( @worklen, 0 ) as AuthorizedSec, 
		IsNull ( @cclen, 0 ) as CCSec, 
		IsNull ( @cconlinelen, 0 ) as CCOnlineSec, 
		IsNull ( @cclunchlen, 0 ) as CCLunchSec
    end

end
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_CallCenter_Info_GetOperatorIndexes_Custom' ) )
	Drop procedure dbo.A_CallCenter_Info_GetOperatorIndexes_Custom
GO


Create procedure dbo.A_CallCenter_Info_GetOperatorIndexes_Custom
	@iduser uniqueidentifier,
	@dtnow datetime = null
as
begin
------------------------------
/*
	declare @iduser uniqueidentifier, @dtnow datetime
	select @iduser = 'DA803F01-EA77-40FA-BC9D-E2EFB36FD5A8', @dtnow = null
*/
------------------------------
	if ( @dtnow is null )
		set @dtnow = GetDate ( )

	declare @dtday datetime
	set @dtday = Cast ( Floor ( Cast ( @dtnow as float ) ) as datetime )

	if ( @iduser = '00000000-0000-0000-0000-000000000000' )
	begin
		--     
		
		-- Select iduser, ' 1:', ' 1', 
		-- 
		-- Select * From #t

		--          . 
		--  -  ,     ,   - 

		--Select Id, '   :', cast ( Len ( Name ) as nvarchar ( 50 ) )
		--From A_Users
		--Union
		--Select Id, ':', Login
		--From A_Users

		Set @iduser = @iduser
	end
	else
	begin
		--     

		-- Select ' 1:', ' 1'
		-- Select * From #t

		--          . 
		--  -  ,     ,   - 

		Set @iduser = @iduser
	end

end
GO