if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_PlugIns' ) )
	if not Exists ( Select * From INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_PlugIns' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'LoadMoment' )
	Alter Table dbo.A_PlugIns
	Add LoadMoment int NULL
GO


Update dbo.A_Plugins
Set LoadMoment = 0
Where LoadMoment is NULL
GO


if exists ( select * from sysobjects where id = object_id ( 'dbo.A_PlugIns_Save' ) )
	Drop procedure dbo.A_PlugIns_Save
GO

Create procedure dbo.A_PlugIns_Save
	@id uniqueidentifier,
	@type int,
	@objectname nvarchar ( 400 ) = null,
	@name nvarchar ( 400 ),
	@description Text = null,
	@path nvarchar ( 1000 ) = null,
	@loadtype int = 1,
	@loadmoment int = 0
as
begin
	Update A_PlugIns
	Set 	Type = @type,
		ObjectName = @objectname,
		Name = @name,
		Description = @description,
		Path = @path,
		LoadType = @loadtype,
		LoadMoment = @loadmoment
	Where Id = @id

	if ( @@rowcount = 0 )
		Insert 
		Into A_PlugIns ( Id, Type, ObjectName, Name, Description, Path, LoadType, LoadMoment )
		Values ( @id, @type, @objectname, @name, @description, @path, @loadtype, @loadmoment )
end
GO



if exists ( select * from sysobjects where id = object_id ( 'dbo.A_PlugIns_GetAll' ) )
	Drop procedure dbo.A_PlugIns_GetAll
GO

Create procedure dbo.A_PlugIns_GetAll
as
begin
	Select Id, Type, ObjectName, Name, Description, Path, LoadType, LoadMoment
	From A_PlugIns
	Order by Name	
end
GO