if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_VoiceMail_GetDataForUser' ) )
	Drop procedure dbo.A_VoiceMail_GetDataForUser
GO

Create procedure [dbo].[A_VoiceMail_GetDataForUser]
	@userid			uniqueidentifier,
	@onlynew		int,
	@topcount		int = -1
as
begin

/*
	Update A_VoiceMail
	Set RecievedTime = GetDate (),
		WhoRecieved = @userid	
	Where RecieverId = @userid
		and IsShown = 0;
*/
	Declare @tmp table ( idx int identity ( 1, 1 ), Id uniqueidentifier, FilePath ntext, IsShown int, SentTime datetime, RecievedTime datetime, Info ntext, CallerId varchar(500), WhoRecieved uniqueidentifier, UName nvarchar(500) )

	Insert into @tmp
		Select vm.Id, FilePath, IsShown, SentTime, RecievedTime, vm.Info, CallerId, WhoRecieved, u.Name
		From A_VoiceMail vm
			left join A_Users u on vm.WhoRecieved = u.Id
		Where ( RecieverId = @userid )
			And (( IsShown = 0 ) or ( @onlynew = 0 ))
		Order By SentTime

	if ( @topcount <= 0 )
		Select Id, FilePath, IsShown, SentTime, RecievedTime, Info, CallerId, WhoRecieved, UName 
		From @tmp
	else
		Select Id, FilePath, IsShown, SentTime, RecievedTime, Info, CallerId, WhoRecieved, UName 
		From @tmp 
		Where idx <= @topcount

/*
	Update A_VoiceMail
	Set IsShown = 1
	Where RecieverId = @userid
		and IsShown = 0;
*/
	
end
GO