if exists ( Select * From sysobjects Where id = object_id ( 'dbo.sp_hexadecimal' ) )
	Drop Procedure dbo.sp_hexadecimal
GO

CREATE PROCEDURE sp_hexadecimal
	@binvalue varbinary(255),
	@hexvalue varchar(255) OUTPUT
AS
Begin
	DECLARE @charvalue varchar(255)
	DECLARE @i int
	DECLARE @length int
	DECLARE @hexstring char(16)
	SELECT @charvalue = '0x'
	SELECT @i = 1
	SELECT @length = DATALENGTH(@binvalue)
	SELECT @hexstring = '0123456789abcdef'
	WHILE (@i <= @length) BEGIN
		DECLARE @tempint int
		DECLARE @firstint int
		DECLARE @secondint int
		SELECT @tempint = CONVERT(int, SUBSTRING(@binvalue,@i,1))
		SELECT @firstint = FLOOR(@tempint/16)
		SELECT @secondint = @tempint - (@firstint*16)
		SELECT @charvalue = @charvalue +
			SUBSTRING(@hexstring, @firstint+1, 1) +
			SUBSTRING(@hexstring, @secondint+1, 1)
		SELECT @i = @i + 1
	END
End
GO


if exists ( Select * From sysobjects Where id = object_id ( 'dbo.sp_displayoaerrorinfo' ) )
	Drop Procedure dbo.sp_displayoaerrorinfo
GO

CREATE PROCEDURE dbo.sp_displayoaerrorinfo
	@object int,
	@hresult int
AS
Begin
	DECLARE @output varchar(255)
	DECLARE @hrhex char(10)
	DECLARE @hr int
	DECLARE @source varchar(255)
	DECLARE @description varchar(255)
	PRINT 'OLE Automation Error Information'
	EXEC sp_hexadecimal @hresult, @hrhex OUT
	SELECT @output = ' HRESULT: ' + @hrhex
	PRINT @output
	EXEC @hr = sp_OAGetErrorInfo @object, @source OUT, @description OUT
	IF @hr = 0 BEGIN
		SELECT @output = ' Source: ' + @source
		PRINT @output
		SELECT @output = ' Description: ' + @description
		PRINT @output
	END
	ELSE BEGIN
		PRINT ' sp_OAGetErrorInfo failed.'
		RETURN
	END
End
GO


if exists ( Select * From sysobjects Where id = object_id ( 'dbo.A_DB_SaveStreamAsFile' ) )
	Drop Procedure dbo.A_DB_SaveStreamAsFile
GO

if exists ( Select * From sysobjects Where id = object_id ( 'dbo.sp_SaveStreamAsFile' ) )
	Drop Procedure dbo.sp_SaveStreamAsFile
GO

CREATE PROCEDURE dbo.sp_SaveStreamAsFile 
	@FilePath nvarchar(2000), -- 
	@table nvarchar(2000),
	@field nvarchar(2000),
	@condition nvarchar(2000)
AS
Begin

	Declare
		@lenquery nvarchar(2000), --'Select @k = DataLength(Stream) From A_Streams Where Name like ''WP'''
		@query nvarchar(2000)	  --'Select @k = substring ( Stream, @Pos + 1, @BufSize ) From A_Streams Where Name like ''WP'''

	Set @lenquery = 'Select @k = DataLength (' + @field + ') From ' + @table + ' Where ' + @condition
	Set @query = 'Select @k = SubString (' + @field + ', @Pos + 1, @BufSize ) From ' + @table + ' Where ' + @condition

	Declare
	  	@Stream integer,
 	  	@Buffer varbinary(4096),
	  	@Size integer,
		@Pos integer,
		@BufSize integer,
		@FileNameLocal varchar(2000),
		@HR integer

	set @FileNameLocal = @FilePath

	SET @BufSize = 4096

	EXEC @HR = sp_OACreate 'ADODB.Stream',@Stream OUT
	if @HR != 0 begin
	  --   
 	  EXEC [dbo].[sp_displayoaerrorinfo] @Stream ,@HR
	end

	EXEC @HR = sp_OASetProperty @Stream,'Type',1 -- binary
	EXEC @HR = sp_OASetProperty @Stream,'Mode',3 -- write|read
	EXEC @HR = sp_OAMethod @Stream,'Open'
	

	set @Size = 0
	exec sp_executesql @lenquery, N'@k int output', @k = @Size output
	
	Set @Pos=0

	WHILE @Pos < @Size BEGIN
	  SET @BufSize = CASE WHEN @Size - @Pos < 4096 THEN @Size - @Pos ELSE 4096 END

	  Set @query = 'Select @k = substring (' + @field + ', @Pos + 1, @BufSize ) From A_Streams Where Name like ''WP'''
  	
	  Exec sp_executesql @query, N'@k varbinary(4096) output, @Pos int, @BufSize int', @k = @Buffer output, @Pos = @Pos, @BufSize = @BufSize

	  EXEC @HR = sp_OAMethod @Stream, 'Write', NULL, @Buffer

	  SET @Pos = @Pos + @BufSize
	END

	EXEC @HR = sp_OAMethod @Stream,'SaveToFile',null, @FileNameLocal,2
	EXEC @HR = sp_OAMethod @Stream,'Close'
	EXEC @HR = sp_OADestroy @Stream
END
GO




if ( object_id('sps_GetFileSize', 'P') > 0 )
	Drop procedure sps_GetFileSize
GO

Create procedure sps_GetFileSize 
	@File nvarchar(1000), 
	@Size int = null output 
as
Begin
	set nocount on
	set @Size = -1

	Create table #getfiledetails
	(
	    Alternate_Name nvarchar(32),                   
	    Size int,       
	    Creation_Date int,
	    Creation_Time int,
	    Last_Written_Date int,
	    Last_Written_Time int, 
	    Last_Accessed_Date int,
	    Last_Accessed_Time int,
	    Attributes int
	)

	insert into #getfiledetails exec master..xp_getfiledetails @File
	select @Size = Size from #getfiledetails
	set nocount off
End
GO


if object_id('spi_ImportFileImage', 'P') > 0 
	drop procedure spi_ImportFileImage
GO

Create procedure spi_ImportFileImage
	@table nvarchar(1000),
	@field nvarchar(1000),
	@condition nvarchar(1000),
	@ImporFile nvarchar(1000),
    	@workPATH nvarchar(1000)='C:\TEMP'

as
Begin
	set nocount on
	declare @ErrorCode int, @Size int, @cmd nvarchar(4000), @id int
	set @ErrorCode = 0
	exec sps_GetFileSize @ImporFile, @Size out

	if @Size = -1
	    return -1

	set @cmd = 'cd /D ' + @workPATH + ' & @echo 8.0 > bcp.fmt & @echo 1 >> bcp.fmt & @echo 1 SQLIMAGE 0 '+cast(@Size as nvarchar(10))+' "" 1 FileImage "">> bcp.fmt'
	exec @ErrorCode = master..xp_cmdshell @cmd, no_output

	if @ErrorCode <> 0
	    return -2

	if not exists ( Select * From tempdb..sysobjects Where id = object_id ( 'tempdb..#tFileImage' ) )		
		create table #tFileImage ( FileImage image, idd int identity primary key )

	set @cmd = 'BULK INSERT #tFileImage FROM ''' + @ImporFile + ''' WITH ( formatfile = ''' + @workPATH + '\bcp.fmt'', DATAFILETYPE  = ''widenative'', BATCHSIZE = 1000000 ) set @id = SCOPE_IDENTITY()' 
	
	print 'inserting'
	exec @ErrorCode = sp_executesql @cmd, N'@id int output', @id output
	print 'inserted'

	if @ErrorCode <> 0
	    return -4

	Select * From #tFileImage

	set @cmd = 'Update t 
		Set t.' + @field + ' = s.FileImage 
		From ' + @table + ' t, #tFileImage s 
		Where ' + @condition + ' and s.Idd = ' + cast ( @id as nvarchar ( 10 ) )

	exec sp_SqlExec @cmd
End
GO


Create procedure spi_ImportFileText
	@table nvarchar(1000),
	@field nvarchar(1000),
	@condition nvarchar(1000),
	@ImporFile nvarchar(1000),
    	@workPATH nvarchar(1000)='C:\TEMP'

as
Begin
	set nocount on
	declare @ErrorCode int, @Size int, @cmd nvarchar(4000), @id int
	set @ErrorCode = 0
	exec sps_GetFileSize @ImporFile, @Size out

	if @Size = -1
	    return -1

	set @cmd = 'cd /D ' + @workPATH + ' & @echo 8.0 > bcp.fmt & @echo 1 >> bcp.fmt & @echo 1 SQLNTEXT 0 '+cast(@Size as nvarchar(10))+' "" 1 FileImage "">> bcp.fmt'
	exec @ErrorCode = master..xp_cmdshell @cmd, no_output

	if @ErrorCode <> 0
	    return -2

	if exists ( Select * From tempdb..sysobjects Where id = object_id ( 'tempdb..#tFileImage' ) )
		drop table #tFileImage 
	create table #tFileImage ( FileImage ntext, idd int identity primary key )

	set @cmd = 'BULK INSERT #tFileImage FROM ''' + @ImporFile + ''' WITH ( formatfile = ''' + @workPATH + '\bcp.fmt'', DATAFILETYPE  = ''widechar'', BATCHSIZE = 1000000 ) set @id = SCOPE_IDENTITY()' 
	
	print 'inserting'
	exec @ErrorCode = sp_executesql @cmd, N'@id int output', @id output
	print 'inserted'

	if @ErrorCode <> 0
	    return -4

	Select * From #tFileImage

	set @cmd = 'Update t 
		Set t.' + @field + ' = s.FileImage 
		From ' + @table + ' t, #tFileImage s 
		Where ' + @condition + ' and s.Idd = ' + cast ( @id as nvarchar ( 10 ) )

	exec sp_SqlExec @cmd
End
GO

