
if exists ( select * from sysobjects where id = object_id ( 'dbo.A_DB_DropObject' ))
	Drop procedure dbo.A_DB_DropObject
GO

Create procedure dbo.A_DB_DropObject
	@simplename nvarchar ( 500 ),
	@type int = 0 -- 0-, 1-, 2-, 3-
as
begin
	Exec A_DB_ClearIndexes @simplename
	Exec A_DB_ClearConstraints @simplename


	Declare @sqltext nvarchar(4000)	
	Declare @fullname nvarchar(500)

	Select @simplename = s.name, @fullname = '[' + su.name + '].[' + s.name + ']'
	From sysobjects s
		Inner join sysusers su on s.uid = su.uid
	Where s.id = object_id ( @simplename )	

	if (( @type = 0 ) or ( @type = 1 )) begin

		Set @sqltext = ' If exists ( select * from sysobjects where id = object_id ( ''' + @fullname + ''' ) and OBJECTPROPERTY(id, N''IsUserTable'') = 1)
		    Drop Table ' + @fullname + ' '

		Exec sp_executesql @sqltext
	end

	if (( @type = 0 ) or ( @type = 2 )) begin
		
		Set @sqltext = ' If exists ( select * from sysobjects where id = object_id ( ''' + @fullname + ''' ) and OBJECTPROPERTY(id, N''IsView'') = 1)
		    Drop View ' + @fullname + ' '

		Exec sp_executesql @sqltext
	end

	if (( @type = 0 ) or ( @type = 3 )) begin
	
		Set @sqltext = ' If exists ( select * from sysobjects where id = object_id ( ''' + @fullname + ''' ) and OBJECTPROPERTY(id, N''IsProcedure'') = 1)
		    Drop Procedure ' + @fullname + ' '

		Exec sp_executesql @sqltext
	end
end
GO
