if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_Stat_RingTime' ))
	Drop table dbo.A_Stat_RingTime
GO

Create Table dbo.A_Stat_RingTime
(
	idx int identity ( 1, 1 ),
	IdUser uniqueidentifier,
	IdLine uniqueidentifier,
	StartDT DateTime,
	RingMs int,
	Answered bit,
	GoneOff bit,
	AbonentCount int,
	TimeoutCount int,
	DeclinedCount int
)
GO

if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_Stat_RingTime_Save' ))
	Drop procedure dbo.A_Stat_RingTime_Save
GO

Create procedure dbo.A_Stat_RingTime_Save
	@userid uniqueidentifier,
	@lineid uniqueidentifier,
	@startdt DateTime,
	@ringms int,
	@answered bit,
	@goneoff bit,
	@abonentcount int,
	@timeoutcount int,
	@declinedcount int
as
begin
	Insert into A_Stat_RingTime
	    ( IdUser, IdLine, StartDT, RingMs, Answered, GoneOff, AbonentCount, TimeoutCount, DeclinedCount )
	Values
	    ( @userid, @lineid, @startdt, @ringms, @answered, @goneoff, @abonentcount, @timeoutcount, @declinedcount )
end
GO


if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_DB_SeedUselessData' ))
	Drop procedure dbo.A_DB_SeedUselessData
GO

Create procedure dbo.A_DB_SeedUselessData
as
Begin
	--        
	--  (    -   )

	Set dateformat dmy
	Declare @dt datetime
	Set @dt = DateAdd ( m, -1, GetDate() )

	Delete
	From A_User_NotifyLog
	Where NotifyDateTime < @dt

	Delete
	From A_TaskManager_UserInTask
	Where TimeStart < @dt 

	Delete
	From A_UserStateHistory
	Where TimeChange < @dt 

	Delete
	From A_CallCenter_UserStateHistory
	Where TimeEnter < @dt 

	Delete
	From A_Stat_Talk_Algorythms 
	Where idconnection not in ( Select id from A_Stat_Connections_1x1 )

	Delete
	From A_CallCenter_LastConnected
	Where ( CallTime < @dt ) and ( idtask not in ( Select id From A_TaskManager_Tasks Where active = 1 ) )

	Delete
	From A_Stat_RingTime
	Where StartDT < @dt

End
GO