

If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_settings' )
  If exists ( Select * From oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_ServerIntLines' ))
    If not Exists ( Select * From oktell_settings.INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_ServerIntLines' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'WebsockUserId' )
	Alter Table oktell_settings.dbo.A_ServerIntLines
	Add [WebsockUserId] uniqueidentifier
GO

Update oktell_settings.dbo.A_ServerIntLines
Set WebsockUserId = '00000000-0000-0000-0000-000000000000'
Where WebsockUserId is null
GO


If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_settings' )
  If exists ( Select * From oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_ServerSipLines' ))
    If not Exists ( Select * From oktell_settings.INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_ServerSipLines' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'WebsockUserId' )
	Alter Table oktell_settings.dbo.A_ServerSipLines
	Add [WebsockUserId] uniqueidentifier
GO

Update oktell_settings.dbo.A_ServerSipLines
Set WebsockUserId = '00000000-0000-0000-0000-000000000000'
Where WebsockUserId is null
GO


If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_settings' )
  If exists ( Select * From oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_ServerVirtualLines' ))
    If not Exists ( Select * From oktell_settings.INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_ServerVirtualLines' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'WebsockUserId' )
	Alter Table oktell_settings.dbo.A_ServerVirtualLines
	Add [WebsockUserId] uniqueidentifier
GO

Update oktell_settings.dbo.A_ServerVirtualLines
Set WebsockUserId = '00000000-0000-0000-0000-000000000000'
Where WebsockUserId is null
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_ServerIntLines' ))
	Drop view dbo.A_ServerIntLines
GO

Create View dbo.A_ServerIntLines
As
	Select *
	FROM oktell_settings.dbo.A_ServerIntLines
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_ServerSipLines' ))
	Drop view dbo.A_ServerSipLines
GO

Create View dbo.A_ServerSipLines
As
	Select *
	FROM oktell_settings.dbo.A_ServerSipLines
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_ServerVirtualLines' ))
	Drop view dbo.A_ServerVirtualLines
GO

Create View dbo.A_ServerVirtualLines
As
	Select *
	FROM oktell_settings.dbo.A_ServerVirtualLines
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_View_ServerIntLinesWebsockUsers' ))
	Drop view dbo.A_View_ServerIntLinesWebsockUsers
GO

Create View [dbo].[A_View_ServerIntLinesWebsockUsers]
as
	--    ,    WebsockUser  

	Select Id, Type, ServerId, SystemNum, Enabled, Caption, CityStraight, ParentGroupId, DefaultUserId, WebsockUserId
	From A_ServerIntLines
	
	Union 
	
	Select Id, Type, ServerId, SystemNum, Enabled, Caption, CityStraight, ParentGroupId, DefaultUserId, WebsockUserId
	From A_ServerSipLines

	Union

	Select Id, Type, ServerId, SystemNum, Enabled, Caption, CityStraight, ParentGroupId, DefaultUserId, WebsockUserId
	From A_ServerVirtualLines
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_View_ServerIntLinesDefaultUsers' ))
	Drop view dbo.A_View_ServerIntLinesDefaultUsers
GO

Create View [dbo].[A_View_ServerIntLinesDefaultUsers]
as
	--    ,    WebsockUser  

	Select Id, Type, ServerId, SystemNum, Enabled, Caption, CityStraight, ParentGroupId, DefaultUserId, WebsockUserId
	From A_ServerIntLines
	
	Union 
	
	Select Id, Type, ServerId, SystemNum, Enabled, Caption, CityStraight, ParentGroupId, DefaultUserId, WebsockUserId
	From A_ServerSipLines

	Union

	Select Id, Type, ServerId, SystemNum, Enabled, Caption, CityStraight, ParentGroupId, DefaultUserId, WebsockUserId
	From A_ServerVirtualLines
GO


if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_WorkPlace_GetWebsockUsers' ))
	Drop procedure dbo.A_WorkPlace_GetWebsockUsers
GO

Create procedure [dbo].[A_WorkPlace_GetWebsockUsers]
as
begin
	Select Id, WebsockUserId 
	From A_View_ServerIntLinesDefaultUsers
end
GO

