/****** Object:  StoredProcedure [dbo].[A_Stat_Office_Diagramm_AllCalls]    Script Date: 12/15/2011 12:06:38 ******/
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[A_Stat_Office_Diagramm_AllCalls]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[A_Stat_Office_Diagramm_AllCalls]
GO

CREATE procedure [dbo].[A_Stat_Office_Diagramm_AllCalls]
	@iduser uniqueidentifier,
	@dstart datetime,
	@dstop datetime,
	@tstart datetime,
	@tstop datetime,
	@lentime datetime,
	@taskid uniqueidentifier = null,
	@fromcc bit = null,
	@operatorid uniqueidentifier = null,
	@innerprefix nvarchar ( 100 ) = null,
	@outnumber nvarchar ( 100 ) = null,
	@conntype int = -1,
	@mode int,
	@comment nvarchar(4000) = null
as

begin
-- .  " "


-- ---------------------------------------------------
--declare @iduser uniqueidentifier,
--		@dstart datetime,
--		@dstop datetime,
--		@tstart datetime,
--		@tstop datetime,
--		@lentime datetime,
--		@taskid uniqueidentifier,
--		@fromcc bit,
--		@operatorid uniqueidentifier,
--		@innerprefix nvarchar ( 100 ),
--		@outnumber nvarchar ( 100 ),
--		@conntype int,
--		@mode int,
--		@comment nvarchar(4000)
	
--Select	@iduser='08BADA93-618D-4493-A7DC-112E39C1D5B9',
--		@dstart='2011-12-13 00:00:00',
--		@dstop='2011-12-13 23:59:59.963',
--		@tstart='2006-07-26 8:00:00',
--		@tstop='2006-07-26 16:00:00',
--		@lentime='2006-07-26 00:00:01',
--		@fromcc=0,
--		@conntype=-1,
--		@comment=N'',
--		@mode=5

----0 -  	
----1 -  	!!!!!!!!!
----2 -  
----3 -  
----4 -  
----5 -   
		
--------------------------------------------------------------------

		

	if not exists ( Select * From tempdb..sysobjects where id = object_id('tempdb..#tempstatistics') )
		Select top 0 * into #tempstatistics From A_Stat_Connections_1x1
	else
		delete From #tempstatistics
		
	Insert into #tempstatistics Exec A_Stat_Service_FillTempByFilter
		@iduser,
		@dstart,
		@dstop,
		@tstart,
		@tstop,
		@lentime,
		@taskid,
		@fromcc,
		@operatorid,
		@innerprefix,
		@outnumber,
		@conntype,
		0, -- dont show conf
		@comment
		
	--EStatisticsViewMode.svmByDay:
	if ( @mode = 0 )
 		begin						
			declare @k0 table ( idchain nvarchar (50) collate database_default, timestart datetime )
			
			--  
			declare @tempdate datetime
			set @tempdate = @dstart
			
			while (@tempdate<@dstop)
			begin
			Insert into @k0
			values (null,@tempdate)
			set @tempdate = dateadd(dd,1,@tempdate)
			end
			
			Insert into @k0
				Select IDChain, Max(timestart) as TimeStop
				From #tempstatistics							
				Group by IDChain
				
			Select Year ( timestart ) y, Month ( timestart ) m, Day ( timestart ) d, count ( idchain ) as Count_
			From @k0
			Group by Year ( timestart ), Month ( timestart ), Day ( timestart )
		end

	--EStatisticsViewMode.svmByHour:
	else if ( @mode = 1 )
		begin
			declare @k1 table ( idchain nvarchar (50) collate database_default, timestart datetime )
			Insert into @k1
				Select IDChain, Max(timestart) as timestart
				From #tempstatistics
				Group by IDChain

			--  
			declare @temptime datetime
			set @temptime = @tstart
					
			while (@temptime<@tstop)
			begin
			Insert into @k1
			values (null,@temptime)
			set @temptime = dateadd(hh,1,@temptime)		
			end

			Select DatePart ( hour, timestart ) h, count ( idchain ) as Count_
			From @k1
			Group by DatePart ( hour, timestart )
		end

	--EStatisticsViewMode.svmByOperator:
	else if ( @mode = 2 )
		begin							
			declare @lines2 table ( lineid uniqueidentifier )
			insert into @lines2
				Select Id From A_View_ServerLinesAll
	

			Select uid, sum ( count_ ) count_ from
			(
				Select AUserId as uid, count ( * ) as count_
				From #tempstatistics ts
					Inner Join A_Users u on u.Id = ts.AUserId
				Group by AUserId
			
				Union all
			
				Select BUserId as uid, count ( * ) as count_
				From #tempstatistics ts
					Inner Join A_Users u on u.Id = ts.BUserId
				Group By BUserId

				union

				Select AUserId as uid, count ( * ) as count_
				From #tempstatistics ts
					Inner Join @lines2 l on l.lineid = ts.BLineId
				Where ( ALineNum like 'IVR' )
				Group by AUserId

				Union all
					
				Select BUserId as uid, count ( * ) as count_
				From #tempstatistics ts
					Inner Join @lines2 l on l.lineid = ts.ALineId
				Where ( BLineNum like 'IVR' )
				Group By BUserId
	
			)a
			group by uid
		end

	--EStatisticsViewMode.svmByLine:
	else if ( @mode = 3 )
		begin														
			--declare @lines3 table ( lineid uniqueidentifier )
			--Insert into @lines3
			--	Select Id From A_View_ServerLinesAll

			Declare @lines3 table ( lineid uniqueidentifier, caption nvarchar ( 100 ) collate database_default )
			Insert into @lines3 (lineid, caption)
				Select id, caption From A_View_ServerLinesAll

			
			Select linenum + case when (( not l.caption is NULL ) and ( l.caption != '' )) then ', ' + l.caption else '' end as linenum, 
				count_
			FROM (
				Select lineid, linenum, sum ( count_ ) count_ from
				(
					Select ALineId as lineid, ALineNum as linenum, count ( * ) as count_
					From #tempstatistics ts
						Inner Join @lines3 l on l.lineid = ts.ALineId	
					Group by ALineId, ALineNum
			
					Union all

					Select BLineId as lineid, BLineNum as linenum, 
						count ( * ) as count_
					From #tempstatistics ts
						Inner Join @lines3 l on l.lineid = ts.BLineId
					Group By BLineId, BLineNum

					Union all
	
					Select ALineId as lineid, ALineNum as linenum, count ( * ) as count_
					From #tempstatistics ts 
						Inner Join @lines3 l on l.lineid = ts.BLineId
					where ALineNum like 'IVR' 
					Group by ALineid, ALineNum

					Union all

					Select BLineId as lineid, BLineNum as linenum, count ( * ) as count_
					From #tempstatistics ts
						Inner Join @lines3 l on l.lineid = ts.ALineId
					where BLineNum like 'IVR'
					Group by BLineId, BLineNum
				)a				
				group by lineid, linenum
			)b
				Left join @lines3 l on b.lineid = l.lineid
		end

	--EStatisticsViewMode.svmByNumber:						
	else if ( @mode = 4 )
	begin
		declare @t table ( nid uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, addrtype int, reactid uniqueidentifier )
		declare @temp table ( id uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, addrtype int, oldrid uniqueidentifier, newrid uniqueidentifier )
				
		Insert Into @t
			Select np.Id, np.Prefix, rr.InnerAddressType, rr.ReactId
			From A_NumberPlan np
				Inner Join A_NumberPlanAction na on na.NumId = np.Id
				Inner Join A_Rules r on na.ExtraId = r.Id
				Inner Join A_RuleRecords rr on rr.RuleId = r.Id


		declare @cnt int
		set @cnt = 0

		while ( @@rowcount > 0 ) and ( @cnt < 10 )
		begin
			Set @cnt = @cnt + 1
	
			/*    @cnt - */
			Insert Into @temp
				Select t.nid, t.prefix, t.addrtype, t.reactid, t1.reactid
				From @t t
					Inner Join @t t1 on t.Reactid = t1.nId
				Where t.ReactId != t.Nid
	
			/*    */
			Delete From @t
				From @temp
			Where nid = id and reactid = oldrid

			/* */
			Insert Into @t ( nid, prefix, addrtype, reactid )
				Select id, prefix, addrtype, newrid From @temp

			/* */
			Delete From @temp	
		end

		declare @lines4 table ( lineid uniqueidentifier )
		insert into @lines4
			Select Id From A_View_ServerIntLinesAll

		Select prefix, sum ( count_ ) count_ from
		(
			Select t1.prefix, 0 as InnerAddrType, count ( * ) as count_
			From #tempstatistics t 
				Inner Join @t t1 on t1.reactid = t.BUserId and t1.addrtype = 0 
				Inner Join A_Users u on u.id = AUserId
			Group by prefix

			Union all

			Select t1.prefix, 0 as InnerAddrType, count ( * ) as count_
			From #tempstatistics t 
				Inner Join @t t1 on t1.reactid = t.BUserId and t1.addrtype = 0 
				Inner Join A_Users u on u.id = BUserId
			Group by prefix

			Union all

			Select t1.prefix, 1 as InnerAddrType, count ( * ) as count_
			From #tempstatistics t 
				Inner Join @t t1 on t1.reactid = t.ALineId and t1.addrtype = 1 
				Inner Join @lines4 l on l.lineid = ALineId
			Group by prefix

			Union all
		
			Select t1.prefix, 1 as InnerAddrType, count ( * ) as count_
			From #tempstatistics t 
				Inner Join @t t1 on t1.reactid = t.BLineId and t1.addrtype = 1 
				Inner Join @lines4 l on l.lineid = BLineId
			Group by prefix
		)a
		Group by prefix
	end
	--EStatisticsViewMode.svmByWeekDay:
	else if ( @mode = 5 )
		begin
			declare @k2 table ( idchain nvarchar (50) collate database_default, timestop datetime )
			Insert into @k2
				Select IDChain, Max(TimeStart) as TimeStop
				From #tempstatistics
				Group by IDChain
			
			--   
			insert into @k2 
			values		(null,'2011-12-12')
			insert into @k2 
			values		(null,'2011-12-13')
			insert into @k2 
			values		(null,'2011-12-14')
			insert into @k2 
			values		(null,'2011-12-15')
			insert into @k2 
			values		(null,'2011-12-16')
			insert into @k2 
			values		(null,'2011-12-17')
			insert into @k2 
			values		(null,'2011-12-18')
			
			--select * from @k2
			
			Select (DatePart(dw, TimeStop)+5)%7 WDay, count ( idchain ) as Count_
			From @k2
			Group by (DatePart(dw, TimeStop)+5)%7
			Order by WDay
		end

	delete From #tempstatistics

end

GO


